#ifndef __KMMPLUGINMANAGER_H_
#define __KMMPLUGINMANAGER_H_

//KDE stuff...
#include <kdialogbase.h>
#include <klocale.h>
#include <kstandarddirs.h>
#include <kfiledialog.h>
#include <kmessagebox.h>
#include <kconfig.h>
#include <kapplication.h>
#include <kdebug.h>
#include <kprocess.h>

//Qt stuff...
#include <qwidget.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <qframe.h>
#include <qtoolbutton.h>
#include <qgroupbox.h>
#include <qslider.h>
#include <qframe.h>
#include <qspinbox.h>
#include <qtextbrowser.h>

class XMameCfg : public KDialogBase
{
Q_OBJECT;
public:
	XMameCfg(QWidget *parent=0);
	~XMameCfg();

/* undefined */

	KConfig *config;
	QString loadedOptions;

#if KDE_VERSION >= 306
	KProcess adProc;
	KProcess nfoProc;
#else
	KShellProcess adProc;
	KShellProcess nfoProc;
#endif
	QStringList paths;

/*general*/
	QLineEdit *pthXmameRoms;
	QLineEdit *pthXmameSamples;
	QLineEdit *pthXmameArt;
	QLineEdit *pthXmameSdlBin;
	QLineEdit *pthXmameX11Bin;
	QLineEdit *pthXmameGlBin;
	QLineEdit *pthXmameSvgaLibBin;

	QCheckBox *chkOutput;
	QCheckBox *chkColorOutput;
	QCheckBox *chkCheatMode;
	QCheckBox *chkDetachProcess;
	QComboBox *xMameType;
	QComboBox *cbConfigType;

/*screen*/
	QComboBox *cbBpp;
	QCheckBox *chkX11FullScreen;
	QCheckBox *chkSdlFullScreen;
	QCheckBox *chkGlFullScreen;
	QCheckBox *chkSvgaLibFullScreen;

/*audio...*/
	QCheckBox *chkIsSound;
	QCheckBox *chkSamples;
	QCheckBox *chkFakeSound;

	QCheckBox *chkCustomAudioSf;
	QCheckBox *chkCustomAudioBufSize;
	QCheckBox *chkCustomAudioDevice;
	QCheckBox *chkCustomAudioMixerDevice;

	QLineEdit *audioSfEdit;
	QLineEdit *audioBufSizeEdit;
	QSlider *audioSetVolume;
	QLineEdit *audioDeviceEdit;
	QLineEdit *audioMixerDeviceEdit;
	QLabel *lblDisplayVolume;

/*video*/
	QComboBox *videoFx;

	QCheckBox *chkEnableFrameSkip;
	QCheckBox *chkFrameSkip;
	QSpinBox *spnMaxAutoFrameSkip;
	QSpinBox *spnNoAutoFrameSkip;

	QGroupBox* rotationBox;
	QCheckBox* chkFlipX;
	QCheckBox* chkFlipY;
	QComboBox* cbRotation;

//FX (effects)
	QCheckBox* chkScanlines;
	QCheckBox* chkArtwork;
	QCheckBox* chkBackdrops;
	QCheckBox* chkOverlay;
	QCheckBox* chkBezel;
	QCheckBox* chkArtCrop;
	QCheckBox* chkThrottle;
	QCheckBox* chkSleepIdle;
	QSpinBox* spnBrightness;
	QSpinBox* spnFrames;
	QSpinBox* spnXScale;
	QSpinBox* spnYScale;
	QSpinBox* spnScaleVideo;
	QSpinBox* spnArtResolution;
	QLineEdit* edtGamma;
	QLineEdit* edtAspectRatio;

//devices
	QComboBox *inputBox;
	QCheckBox *chkAnalogStick;
	QLineEdit *customJoyDevName;
	QCheckBox *chkUseHotRod;
	QCheckBox *chkUseHotRodSe;
	QCheckBox *chkUsbPsPad;
	QCheckBox *chkRapidFire;
	QCheckBox *chkGrabMouse;

//info
	QTextBrowser* versionBrowser;

private slots:
//module loader...
	void loadModules();

//existing modules...
	void modScreen();
	void modAudio();
	void modGeneral();
	void modPaths();
	void modFirstRun();
	void modVideo();
	void modDevices();
	void modEffects();
	void modInfo();

	void loadConfig();
	void writeConfig();
	void saveOptions();

//buttons
	void slotSetSdlMameBin();
	void slotSetX11MameBin();
	void slotSetGlMameBin();
	void slotSetSvgaLibMameBin();
	void slotSetXMameRomDir();
	void slotSetXMameSamplesDir();
	void slotSetXMameArtDir();
//everything else
	void setDefaultPaths( KProcess *, char *, int);
	void setVersionInfo( KProcess *, char *, int);
	void changeVolumeLevel(int);
	void slotConfigType(int);
	void reload();

protected slots:
	void slotOk();

signals:
	void listenConfOk();
};

#endif
