#include "toolromlister.h"
ToolRomListerPlugin::ToolRomListerPlugin()
{
//connections...
	connect(btnClose, SIGNAL(clicked()), this, SLOT(close()) );
	connect(&pProc, SIGNAL( processExited (KProcess *)), this, SLOT( getStoppedStatus(KProcess *)) );
	connect(&m_proc, SIGNAL( processExited (KProcess *)), this, SLOT( getOkStatus(KProcess *)) );
	config = kapp->config();
	get_lock = 0;
}

ToolRomListerPlugin::~ToolRomListerPlugin()
{

}

QString ToolRomListerPlugin::detectBin(int mode)
{
	QString conf_xmameBinPath;
	config->setGroup("general");
	if (mode == 0)
		conf_xmameBinPath=config->readEntry("xmame_sdl","");
	else if(mode == 1)
		conf_xmameBinPath=config->readEntry("xmame_x11","");
	else if(mode == 2)
		conf_xmameBinPath=config->readEntry("xmame_gl","");
	else if(mode == 3)
		conf_xmameBinPath=config->readEntry("xmame_svga","");

	return conf_xmameBinPath;
}

void ToolRomListerPlugin::slotReload()
{
	addRoms();
}

void ToolRomListerPlugin::addRoms()
{
	config->setGroup("general");
	QString mameRomPath = " -rp "+config->readEntry("xmame_rom","");
	romBox->clear();
	for (int i = 0; i <=3; i++) //mode detector
	{
		if (!detectBin(i).isEmpty())
		{
			addBin = detectBin(i);
			break;
		}
	}
	kdDebug() << addBin << endl;

	pProc.clearArguments();
	#if KDE_VERSION >= 306
		pProc.setUseShell(true);
		m_proc.setUseShell(true);
	#endif

	switch (romType -> currentItem())
	{
		case 0 :
			if (QFile::exists(locateLocal("data", "kmameleon/") + "roms.xmame"))
				QFile::remove(locateLocal("data", "kmameleon/") + "roms.xmame"); // clear the file...

			pProc << addBin << " -lrs >" + locateLocal("data", "kmameleon/") + "roms.xmame";
			if (! pProc.start(KProcess::NotifyOnExit, KProcess::AllOutput))
				KMessageBox::error( 0, i18n("Couldn't load a program") );
		break;

		case  1:
			if (QFile::exists(locateLocal("data", "kmameleon/") + "goodroms.xmame"))
				QFile::remove(locateLocal("data", "kmameleon/") + "goodroms.xmame"); // clear the file...

			pProc << addBin << mameRomPath << " -vrs | grep -w \"correct\">" + locateLocal("data", "kmameleon/") + "goodroms.xmame";
			if (! pProc.start(KProcess::NotifyOnExit, KProcess::AllOutput))
				KMessageBox::error( 0, i18n("Couldn't load a program") );
		break;

		case 2:
			if (QFile::exists(locateLocal("data", "kmameleon/") + "badroms.xmame"))
				QFile::remove(locateLocal("data", "kmameleon/") + "badroms.xmame"); // clear the file...

			pProc << addBin << mameRomPath << " -vrs | grep -w \"incorrect\">" + locateLocal("data", "kmameleon/") + "badroms.xmame";
			if (! pProc.start(KProcess::NotifyOnExit, KProcess::AllOutput))
				KMessageBox::error( 0, i18n("Couldn't load a program") );
		break;

		case 3:
			if (QFile::exists(locateLocal("data", "kmameleon/") + "missingroms.xmame"))
				QFile::remove(locateLocal("data", "kmameleon/") + "missingroms.xmame"); // clear the file...

			pProc << addBin << mameRomPath << " -vrs | grep -w \"not found\">" + locateLocal("data", "kmameleon/") + "missingroms.xmame";
			if (! pProc.start(KProcess::NotifyOnExit, KProcess::AllOutput))
				KMessageBox::error( 0, i18n("Couldn't load a program") );
		break;
	}

	if (pProc.isRunning())
	{
		btnReload -> setEnabled(false);
		romType -> setEnabled (false);
	}
}

void ToolRomListerPlugin::fetchList()
{
	QString filename;
	switch (romType -> currentItem())
	{
		case 0 :
			filename = ( locateLocal("data", "kmameleon/") + "roms.xmame" );
		break;
		case 1 :
			filename = ( locateLocal("data", "kmameleon/") + "goodroms.xmame" );
		break;
		case 2 :
			filename = ( locateLocal("data", "kmameleon/") + "badroms.xmame" );
		break;
		case 3 :
			filename = ( locateLocal("data", "kmameleon/") + "missingroms.xmame" );
		break;
	}

	if ( !fillRomList( romBox, filename ) )
	{
		(void) new QListViewItem( romBox, i18n( "No ROMs Found" ),
			i18n( "Could not load file '%1', %2" ).arg( filename ).arg( strerror( errno ) ) );
	}
}

bool ToolRomListerPlugin::fillRomList( QListView *lv, const QString &filename )
{
	// Load file
	QFile f( filename );
	if ( !f.open(IO_ReadOnly) )
	{
		kdDebug() << "Could not open file '" << filename << "', "  << strerror( errno ) << endl;
		return false;
	}

	QByteArray raw = f.readAll();
	QString txt( QString::fromLocal8Bit( raw ) );
	kdDebug() << "Loaded " << txt.length() << " chars from " << filename << endl;

	// Parse contents
	QStringList sl = QStringList::split("\n",txt);
	QStringList ent;
	for (unsigned int i=2; i < sl.size(); i++)
	{
		switch (romType -> currentItem())
		{
			case 0: //all roms
				ent = QStringList::split("\t", sl[i]);
				if (! ent[1].isEmpty())
					(void) new QListViewItem( lv, ent[0].stripWhiteSpace(), 0l, ent[1] );
			break;
			case 1: //correct roms
				ent = QStringList::split(" ", sl[i]);
				if (ent[1].stripWhiteSpace() == "correct")
					(void) new QListViewItem( lv, ent[0].stripWhiteSpace(), 0l, 0l );
			break;
			case 2: //bad roms
				ent = QStringList::split(" ", sl[i]);
				if (ent[1].stripWhiteSpace() == "incorrect")
					(void) new QListViewItem( lv, ent[0].stripWhiteSpace(), 0l, 0l );
			break;
			case 3: //missing roms
				ent = QStringList::split(" ", sl[i]);
				if (ent[1].stripWhiteSpace() == "not")
					(void) new QListViewItem( lv, ent[0].stripWhiteSpace(), 0l, 0l );
			break;
		}
	}

	QListViewItem * item;
	//this one is static... It's forte descriptions of the roms...
	QFile t(locateLocal("data", "kmameleon/") + "roms_desc.xmame");
	if ( !t.open(IO_ReadOnly) )
	{
		kdDebug() << "Could not open file '" << "', "  << strerror( errno ) << endl;
	}

	QByteArray raw_desc = t.readAll();
	QString desc( QString::fromLocal8Bit( raw_desc ) );
	kdDebug() << "Loaded " << desc.length() << " chars from " << locateLocal("data", "kmameleon/") + "roms_desc.xmame" << endl;
	QStringList sl_desc = QStringList::split("\n",desc);
	for (unsigned int j=2; j < sl_desc.size(); j++)
	{
		QStringList ent_desc = QStringList::split("\"", sl_desc[j]);
		if(! ent_desc[1].isEmpty())
		{
			item = romBox -> findItem(ent_desc[0].stripWhiteSpace(), 0);
			if (item)
			{
				item -> setText(1,ent_desc[1]);
				switch (romType -> currentItem())
				{
					case 1:
						item -> setPixmap(0, QPixmap(locate("data","kmameleon/tools/img_rom_ok.png")));
					break;
					case 2:
						item -> setPixmap(0, QPixmap(locate("data","kmameleon/tools/img_rom_bad.png")));
					break;
					case 3:
						item -> setPixmap(0, QPixmap(locate("data","kmameleon/tools/img_rom_missing.png")));
					break;
				}
			}
			else
				kdDebug() << "null found!" << ent_desc[0] << endl;
		}
	}

	romCounter -> display(lv->childCount());
	kdDebug () << "Matched " << lv->childCount() << " lines" << endl;
	return true;
}

void ToolRomListerPlugin::getStoppedStatus(KProcess *)
{
	if (get_lock == 0)
	{
		if (QFile::exists(locateLocal("data", "kmameleon/") + "roms_desc.xmame"))
			QFile::remove(locateLocal("data", "kmameleon/") + "roms_desc.xmame"); // clear the file...

		m_proc << addBin << " -lf >" + locateLocal("data", "kmameleon/") + "roms_desc.xmame";
		if (! m_proc.start(KProcess::NotifyOnExit, KProcess::AllOutput))
			KMessageBox::error( 0, i18n("Couldn't load a program") );
		get_lock ++;
	}
	else
	{
		fetchList();
		btnReload -> setEnabled(true);
		romType -> setEnabled (true);
	}
}

void ToolRomListerPlugin::getOkStatus(KProcess *)
{
	fetchList();
	btnReload -> setEnabled(true);
	romType -> setEnabled (true);
}

#include "toolromlister.moc"
